try:
    from .lib.helpers import get_static_paths, get_content_text
    from .lib.classUser import User
except:
    from lib.classUser import User
    from lib.helpers import get_static_paths, get_content_text
from . import app
from flask import Flask, render_template, redirect, url_for, request, flash
from flask_login import LoginManager, UserMixin, login_required, login_user, current_user, logout_user

login_manager = LoginManager()
login_manager.init_app(app)
login_manager.login_view = "login"


'''
@login_manager.user_loader
def load_user(request):
    token = request.headers.get('Authorization')
    if(token is None):
        token = request.args.get('token')

    if(token is not None):
        username, password = token.split(':')  # naive token
        user_entry = User.get(username)
        if(user_entry is not None):
            user = User(user_entry[0], user_entry[1])
            if(user.password == password):
                return user

    return None
'''


@login_manager.user_loader
def load_user(request):
    return User(request, User.user_database[request][1])


@app.route('/home', methods=['GET'])
@login_required
def home():
    return render_template('home/index.html', static_paths=get_static_paths(), content_text=get_content_text())


@app.route('/signup', methods=['GET', 'POST'])
def signup():
    error = 'Invalid method.'
    if(request.method == 'POST'):
        username = request.form['username']
        password = request.form['password']
        if(not username in User.user_database.keys()):
            userClass = User(username, password)
            User.user_database[username] = (username, password)
            return redirect('/')
        else:
            flash('It looks like a user already exists with that name.')
            return redirect('/signup')
    elif(request.method == 'GET'):
        return render_template('signup/index.html', static_paths=get_static_paths(), content_text=get_content_text())
    return f'ERROR: {error}'


@app.route('/login', methods=['GET', 'POST'])
def login():
    error = 'Invalid method.'
    if(request.method == 'POST'):
        username = request.form['username']
        password = request.form['password']
        if(username in User.user_database.keys()):
            userClass = User(username, password)
            login_user(userClass)
            return redirect('home')
        else:
            error = 'Invalid credentials.'
    elif(request.method == 'GET'):
        return render_template('login/index.html', static_paths=get_static_paths(), content_text=get_content_text())
    return f'ERROR: {error}'


@app.route('/logout', methods=['GET', 'POST'])
def logout():
    error = 'Invalid method.'
    if(request.method == 'GET'):
        logout_user()
        return redirect('/')
    return f'ERROR: {error}'


@app.route('/', methods=['GET'])
def hello():
    if(not current_user.is_active):
        return render_template('homepage.html', static_paths=get_static_paths(), content_text=get_content_text())
    else:
        return redirect('home')


def main():
    app.run(host='0.0.0.0', debug=True)
